︠caf2207c-ebac-4ab6-9dc7-3cff5ba83c55︠
# -*- coding: utf-8 -*-
#上面一行表示本程序是采用utf-8字符集编写的。如果去掉，则可能默认是ascii，无法显示汉字

#导入一些packages以及其中的函数
from sympy import *
from sympy.matrices.matrices import *

#定义后面要用到的变量，其中positive=True表示这个变量肯定是正的。如果不显式给出，在开方的时候，可能会出现
#符号i，甚至无法化简(P**2)**(1/2)这种情况
x = Symbol('x')
P = Symbol('P',positive=True)
L = Symbol('L', positive=True)
EI = Symbol('EI', positive=True)

#定义后面要用到的广义坐标,其中 real = True 表示这个变量是实数，理由与上面的类似
a = Symbol('a',real = True)
b = Symbol('b',real = True)
c = Symbol('c',real = True)

#计时用函数
import  time 
START = time.time()
︡c781a67a-abce-4e25-a591-c76098c77d00︡︡
︠0abee0df-90e9-4e25-a882-6f9fdc38742e︠
#左边这个井号表示这一行是注释
#下面三行是三种情况对应的命令
#左边是变量得名称，右边依次为： 近似曲线              , [广义位移], 计算方法

y , unknown , METHOD   =   a*(x**2-x**3/(2*L))   , [a]    , "M"

#y , unknown , METHOD  =   a*(x**2-x**3/L)      , [a]      , "y''"
#y ,  unknown , METHOD  =   a*(1-cos(pi*x/2/L)) , [a]      , "M"

#类似的命令只能存在一条，若超过一条，以此框中最后一个为准
#修改此框中命令后，在顶部选择Action...，然后选择evaluate all就会自动计算
#结果见最后两个框
︡7f9eaaec-c792-4147-9a54-84c055efa98a︡︡
︠6223e4ae-009e-4aa8-8c75-ce5d9f07f1b2︠
dy = diff(y,x)
dy2 = diff(y,x,2)

#仅仅为了显示结果更好看而已
Stringsub = r"""\begin{array}{l}"""
Stringend = r"""\end{array}"""
Temp = "y =" + latex(y)
Temp += r"\\\frac{\rm{d}y}{\rm{d}x} = "+latex(dy)
Temp += r"\\\frac{{\rm{d}}^2y}{{\rm{d}x}^2} = "+latex(dy2)
String = Stringsub + Temp + Stringend
LatexExpr(String)
︡3ec1e6ec-8bcd-4677-9b15-88a5be16bbdf︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\begin{array}{l}y =a \\left(x^{2} - \\frac{x^{3}}{2 L}\\right)\\\\\\frac{\\rm{d}y}{\\rm{d}x} = a \\left(2 x - \\frac{3}{2} \\frac{x^{2}}{L}\\right)\\\\\\frac{{\\rm{d}}^2y}{{\\rm{d}x}^2} = a \\left(2 - 3 \\frac{x}{L}\\right)\\end{array}</span>"}︡
︠c3f5d12a-1e56-495d-91ce-2c3256bd5b99︠
#对于不同的弹性稳定问题，要修改此框
D = integrate((diff(y,x))**2/2 , (x,0,L))
print "荷载方向位移:Delta = ",D
︡74e84c40-743d-4229-b3ae-4cd93e2ae811︡{"stdout": "\u8377\u8f7d\u65b9\u5411\u4f4d\u79fb:Delta =  17*L**3*a**2/120"}︡
︠1c34bd37-398c-4dd4-a3d2-0ed8adee11bc︠
#仅仅为了显示结果更好看而已
LatexExpr("\Delta = "+latex(D))
︡c4464c4e-9261-47fd-b265-29f8f4f7f3d3︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Delta = \\frac{17}{120} L^{3} a^{2}</span>"}︡
︠6b859030-ef11-4d6f-be60-8de918f73a93︠
if METHOD == "y''":
    PI = integrate(EI*dy2**2/2,(x,0,L))-P*D
elif METHOD == "M":
    M = P*(y.subs(x,L) - y)
    PI = integrate(M**2/2/EI,(x,0,L))-P*D
else:
    print "未定义方法:",METHOD
    PI = 0
print "能量泛函:PI = \n",PI
︡f92a3f9b-e403-4932-9711-2f409b0c160d︡{"stdout": "\u80fd\u91cf\u6cdb\u51fd:PI = \n-17*L**3*P*a**2/120 + 31*L**5*P**2*a**2/(560*EI)"}︡
︠fd95726c-1e6d-44b4-8842-38c102db98f7︠
Stringsub = r"\begin{array}{l}"+"\n"
Stringend = "\n"+r"\end{array}"
Temp = r"\Pi = "

if METHOD == "y''":
    Temp += "\n"+r"""\int_0^L 
                        {\frac{1}{2} EI ({ \frac{\rm{d}^2y} {\rm{d}x^2}})^2} 
                  {\rm{d}x}
                   - P\Delta"""
elif METHOD == "M":
    Temp += "\n"+r"""\int_0^L 
                        \frac{1}{2} \frac{M^2}{EI}
                  \rm{d}x
                   - P\Delta"""
else:
    print "未定义方法:",METHOD
    PI = 0
    
Temp += (r"\\"+"\n="+latex(PI))
Temp += Stringend
Temp = Stringsub+Temp
LatexExpr(Temp)
︡ff0efaaf-6855-46be-b434-93bfa3f8daf4︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\begin{array}{l}\n\\Pi = \n\\int_0^L \n                        \\frac{1}{2} \\frac{M^2}{EI}\n                  \\rm{d}x\n                   - P\\Delta\\\\\n=- \\frac{17}{120} L^{3} P a^{2} + \\frac{31}{560} \\frac{L^{5} P^{2} a^{2}}{EI}\n\\end{array}</span>"}︡
︠e5c12af9-25b0-436f-9456-d2224c25e109︠
EQs = Matrix([PI]).jacobian(unknown)
print "平衡方程:"
for e in EQs: print e," = 0",'\n'
︡d5f64953-ec55-4d9c-ac7d-6b4dda8676a5︡{"stdout": "\u5e73\u8861\u65b9\u7a0b:\n-17*L**3*P*a/60 + 31*L**5*P**2*a/(280*EI)  = 0"}︡
︠1f8dff74-9032-44b3-b70b-644ec24589c9︠
#仅仅为了显示结果更好看而已
Temp = r"""\begin{array}{c}"""
Stringend = "\n"+r"""\end{array}"""

for i in range(len(unknown)):
    Temp += "\n"+r"\\ " + r"\frac{\delta \Pi}{\delta " + latex(unknown[i])+"} =" + latex(EQs[i])+" = 0"
    
Temp += Stringend
Temp = Temp.replace(r"\\","",1)
LatexExpr(Temp)
︡fefcf744-9e7a-429a-bd08-57b5f143e60f︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\begin{array}{c}\n \\frac{\\delta \\Pi}{\\delta a} =- \\frac{17}{60} L^{3} P a + \\frac{31}{280} \\frac{L^{5} P^{2} a}{EI} = 0\n\\end{array}</span>"}︡
︠a1aad3b5-dd49-42a1-a498-445209c02205︠
EQ = Matrix(EQs).jacobian(unknown).det()
print "二阶变分行列式值:\n",pretty(EQ)
︡8a461363-15f9-4dd1-8851-1cf1e623da42︡{"stdout": "\u4e8c\u9636\u53d8\u5206\u884c\u5217\u5f0f\u503c:\n      3         5  2\n  17\u22c5L \u22c5P   31\u22c5L \u22c5P \n- \u2500\u2500\u2500\u2500\u2500\u2500\u2500 + \u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\n     60      280\u22c5EI"}︡
︠2b26ecc6-79b9-482c-8623-191f5aa9e617︠
#仅仅为了显示结果更好看而已
LatexExpr(r"|{\delta^2\Pi}| = " + latex(EQ))
︡32e69257-2872-4487-b828-1857a2d2f488︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}|{\\delta^2\\Pi}| = - \\frac{17}{60} L^{3} P + \\frac{31}{280} \\frac{L^{5} P^{2}}{EI}</span>"}︡
︠36f4391f-2800-4430-a216-4eb24795cb39︠
Pcr = solve( EQ, P)
if 0 in Pcr :Pcr.remove(0)
if len(unknown)>1:
    Pcr.sort()
    Model = []
    temp = [solve(EQs.subs(P,min(Pcr)).subs(unknown[0],1)[1:],unknown[1:])]
    for p in Pcr:
        temp = solve(EQs.subs(P,p).subs(unknown[0],1)[1:],unknown[1:])
        m = [1]
        for u in unknown[1:]:
            m.append(temp[u])
        Model.append(m)
else:
    Model = [[1]]
for i in range(len(unknown)):
    print "第",i+1,"模态:",Model[i],"\n对应失稳荷载:Pcr=\n",pretty(Pcr[i]),'\n'
︡3be70c4d-8ba5-455d-b578-9586b259fbb7︡{"stdout": "\u7b2c 1 \u6a21\u6001: [1] \n\u5bf9\u5e94\u5931\u7a33\u8377\u8f7d:Pcr=\n238\u22c5EI\n\u2500\u2500\u2500\u2500\u2500\u2500\n    2 \n93\u22c5L"}︡
︠f395cc08-0c71-4622-8ab1-4233737fcd18︠
#仅仅为了显示结果更好看而已
Stringsub = r"""\begin{array}{l}"""
Stringend = r"""\end{array}"""
Temp = r"P_{cr1} =" + latex(Pcr[0])
for i in range(1,len(Pcr)):
    Temp += r"\\P_{cr" + str(i+1) + "}=" + latex(Pcr[i])
String = Stringsub + Temp + Stringend
LatexExpr(String)
︡4d6c8f98-0c0c-4d9c-8500-376348090304︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\begin{array}{l}P_{cr1} =\\frac{238}{93} \\frac{EI}{L^{2}}\\end{array}</span>"}︡
︠3e208a4d-abf2-48e7-995d-0bd7a6c88485︠
print "数值结果:"
for i in range(len(unknown)):
    print "第",i+1,"模态:",[m.evalf() for m in Model[i]],"\n对应失稳荷载:\n\tPcr=",Pcr[i].evalf(),'\n'
︡f2bf6b69-9877-4405-b227-30a07112344a︡{"stdout": "\u6570\u503c\u7ed3\u679c:\n\u7b2c 1 \u6a21\u6001: [1.00000000000000] \n\u5bf9\u5e94\u5931\u7a33\u8377\u8f7d:\n\tPcr= 2.55913978494624*EI/L**2"}︡
︠ddb8465c-a51e-4a27-8038-5a2f86392c52︠
print "计算总耗费时间:",time.time()-START,"s"
︡13b36f31-23d5-46d5-bb9a-69421d2e0c1b︡{"stdout": "\u8ba1\u7b97\u603b\u8017\u8d39\u65f6\u95f4: 6.95691299438 s"}︡
︠2eae5bc8-9837-4ee1-9234-632152b10343︠
"""
    虽然只是一个很简单的题目，手算也不会很难，但是我很重视通用性，希望可以一次性解决所有类似的问题，所以我还是为此写了这段程序，并且调试了一下输出效果。
    有了这段程序，以后就可以集中于位移的计算和能量泛函表达，而不是无聊的推导过程了。也不用一直担心是不是推导过程出错了。因为如果这段程序没有算出结果，问题应该仅仅在于位移函数本身不符合边界条件，或者泛函没写对。
很感谢你的关注。
"""
︡8ad64174-9deb-49ef-9c0b-f92a5fbd88a8︡︡
